%add_findprov_lib_path %_libdir/ocaml
%add_findprov_lib_path %_libdir/ocaml/stublibs/
%add_findprov_lib_path %_libdir/ocaml/labltk/
%add_findprov_lib_path %_libdir/ocaml/threads/

Name: ocaml
Version: 3.09.3
Release: alt0.1

Summary: The Objective Caml compiler and programming environment

License: QPL & LGPL
Group: Development/ML
Packager: Pavlov Konstantin <thresh@altlinux.ru>
Obsoletes: ocaml-emacs
AutoReq: yes, noshell
%set_verify_elf_method textrel=relaxed,rpath=relaxed

Url: http://caml.inria.fr/

Source0: %name-%version.tar.bz2
Source1: ocaml-3.08-refman.html.tar.gz
Source2: ocaml-3.08-refman.pdf
Source4: %name.menu
Source5: http://caml.inria.fr/oreilly-book/ocaml-ora-book.pdf
Source7: ocamldoc.sty

# Malc's pathches from http://algol.prosalg.no/~malc/scaml/
#Patch2: ocaml-3.07+14-shared.patch.bz2
# Small and dirty patches.
#Patch6: ocaml-3.04+7-private.patch
Patch7: ocaml-3.04+9-filename.patch
Patch8: ocaml-3.04+7-threadhack.patch
#Patch9: ocaml-3.04+10-odochack.patch
Patch11: ocaml-3.04+10-stdlibdoc.patch
Patch12: ocaml-3.09.1-tinfo.patch

Patch100: ocaml-3.07+14-man3o.patch
# Automatically added by buildreq on Tue Feb 25 2003
# Manually corrected (3.06s-alt3)
BuildRequires: XFree86-devel XFree86-libs latex2html libdb1-devel
BuildRequires: libgdbm-devel libncurses-devel libtcl libtk tcl-devel
BuildRequires: tetex-dvips tetex-latex tk-devel >= 8.4.0-alt1
# Needed for the shared libraries patch
BuildRequires: binutils 

Requires: ocaml-runtime = %version-%release

%package doc
Summary: Documentation for OCaml
Group: Development/ML
Requires: %name = %version-%release

%package -n camlp4
Summary: Preprocessor for OCaml
Group: Development/ML
Requires: %name = %version-%release

%package -n labltk
Summary: Tk toolkit binding for OCaml
Group: Development/ML
Requires: %name = %version-%release, ocaml-graphics = %version-%release
Obsoletes: ocamltk, camltk
Provides: ocamltk = %version

%package -n ocaml-runtime
Summary: Runtime part of the OCaml system
Group: Development/ML
Provides: %_libdir/%name/stdlib.so

%package -n ocaml-graphics
Summary: Graphics module
Requires: ocaml-runtime = %version-%release
Group: Development/ML

%description
Objective Caml is a high-level, strongly-typed, functional and object-oriented
programming language from the ML family of languages.

This package comprises two batch compilers (a fast bytecode compiler and an
optimizing native-code compiler), an interactive toplevel system, Lex&Yacc
tools, a replay debugger, and a comprehensive library.

%description -l ru_RU.KOI8-R
Objective Caml -  , -
     ML.

  ocaml    -    
   (x86) ;  ,
  lex  yacc,      
 .

%description doc -l ru_RU.KOI8-R
  Objective Caml     
 "Developing Applications with Objective Caml".

%description doc
Documentation for OCaml and O'Relly book translation

%description -n camlp4 -l ru_RU.KOI8-R
  Objective Caml (  Standard ML, Lisp-like,
 Revised OCaml, ...).

%description -n camlp4
Preprocessor for OCaml

%description -n labltk
Tk toolkit binding for OCaml

%description -n ocaml-runtime
Runtime part for the both bytecode and some native compiled
binaries.

%description -n ocaml-graphics
Graphics and LablTk runtime.

%prep
%setup -q -T -b 0 
%setup -q -T -D -a 1

%patch100 -p1

%patch7 -p1
%patch8 -p1
%patch11 -p1
%patch12 -p1

# grrr ...
#%__cat <<EOF |ed - emacs/Makefile
#%%s|\(--batch \)|\1--no-site-file |
#wq
#EOF

cp %SOURCE2 %SOURCE5 ./

## replace a bootstrap compiler 
#(cd boot; bzcat %%SOURCE6 | tar -xvvf -)

%build

%__sed -i 's@/usr/X11R6/lib@%_x11libdir@g' configure

%add_optflags -DUSE_NON_CONST -D_FILE_OFFSET_BITS=64
./configure -with-pthread -bindir %_bindir -libdir %_libdir/ocaml -mandir %_mandir
make BYTECCCOMPOPTS="%optflags" NATIVECCCOMPOPTS="%optflags" world
make BYTECCCOMPOPTS="%optflags" NATIVECCCOMPOPTS="%optflags" ocamlopt

## A dirty hack related to the unresolved problem in the 3.07+6 build
## process (missed dependencies).
(cd stdlib; make std_exit.cmx)
(cd stdlib; make stdlib.cmxa)
#####


make BYTECCCOMPOPTS="%optflags" NATIVECCCOMPOPTS="%optflags" opt opt.opt
cp %SOURCE7 ./ocamldoc/
(cd ocamldoc; make stdlib_man stdlib.ps)
mv ocamldoc/stdlib.ps ./
mv ocamldoc/stdlib.pdf ./

%install
make install BINDIR=%buildroot%_bindir LIBDIR=%buildroot%_libdir/ocaml MANDIR=%buildroot%_mandir
mkdir -p %buildroot%_libdir/ocaml/site-lib/

# (cd emacs; make install install-ocamltags BINDIR=%buildroot%_bindir EMACSDIR=%buildroot%_datadir/emacs/site-lisp)

perl -pi -e "s|$RPM_BUILD_ROOT||" $RPM_BUILD_ROOT%_libdir/ocaml/ld.conf

## only keep the binary versions (which are much faster, and have no drawbacks (?))
#for i in $RPM_BUILD_ROOT%_bindir/*.opt ; do
#  nonopt=`echo $i | sed "s/.opt$//"`
#  rm -f $nonopt
#  ln -s `basename $i` $nonopt
#done


rm -f $RPM_BUILD_ROOT%_bindir/ocamlc
rm -f $RPM_BUILD_ROOT%_bindir/ocamlopt
ln -s ocamlc.opt $RPM_BUILD_ROOT%_bindir/ocamlc
ln -s ocamlopt.opt $RPM_BUILD_ROOT%_bindir/ocamlopt

#install -d $RPM_BUILD_ROOT%_sysconfdir/emacs/site-start.d
#cat <<EOF >$RPM_BUILD_ROOT%_sysconfdir/emacs/site-start.d/%name.el
#(require 'caml-font)
#(autoload 'caml-mode "caml" "Caml editing mode" t)
#(add-to-list 'auto-mode-alist '("\\\\.mli?$" . caml-mode))
#EOF

# menu (kept in case we want to use it again one day)
install -d $RPM_BUILD_ROOT%_menudir
install -m 644 %SOURCE4 $RPM_BUILD_ROOT%_menudir/%name


#(cd $RPM_BUILD_ROOT/usr/lib/ocaml/;
# export OOPT=$RPM_BUILD_DIR/ocaml-%version/ocamlopt.opt;
# export OOCMD=" -ccopt -L. -ccopt -Wl,-rpath=/usr/lib/ocaml/:. -ccopt -Wl,-rpath-link=/usr/lib/ocaml/:. -shared -nolinkstd ";
# $OOPT $OOCMD -o stdlib.so stdlib.cmxa -linkall;
# $OOPT $OOCMD -o unix.so stdlib.so.cmxa unix.cmxa -linkall;
# $OOPT $OOCMD -o bigarray.so stdlib.so.cmxa bigarray.cmxa -linkall;
# $OOPT $OOCMD -o nums.so stdlib.so.cmxa nums.cmxa -linkall;
# $OOPT $OOCMD -o str.so stdlib.so.cmxa str.cmxa -linkall;
# $OOPT $OOCMD -o graphics.so stdlib.so.cmxa graphics.cmxa -linkall;
# $OOPT $OOCMD -o dbm.so stdlib.so.cmxa dbm.cmxa -linkall;
# $OOPT $OOCMD -o threads/threads.so stdlib.so.cmxa threads/threads.cmxa -linkall;
# $OOPT $OOCMD -ccopt -L./labltk/ -o labltk/labltk.so stdlib.so.cmxa labltk/labltk.cmxa -linkall;
# $OOPT $OOCMD -ccopt -L./labltk/ -o labltk/jpflib.so stdlib.so.cmxa labltk/jpflib.cmxa -linkall;
# $OOPT $OOCMD -ccopt -L./labltk/ -o labltk/frxlib.so stdlib.so.cmxa labltk/frxlib.cmxa -linkall;
# $OOPT $OOCMD -ccopt -L./labltk/ -o labltk/tkanim.so stdlib.so.cmxa labltk/tkanim.cmxa -linkall
#)

export EXCLUDE_FROM_STRIP="ocamlc ocamlopt camlp4o camlp4r"

rm -f %name.list
n="labltk|camlp4|ocamlbrowser|stublibs|ocamlrun|ld.conf"
(cd $RPM_BUILD_ROOT ; find usr/bin ! -type d -printf "/%%p\n" | egrep -v $n) >> %name.list
(cd $RPM_BUILD_ROOT ; find usr/%_lib/ocaml ! -type d ! -name '*.so' -printf "/%%p\n" | egrep -v $n | egrep -v "graphics") >> %name.list
#(cd $RPM_BUILD_ROOT ; find usr/lib/ocaml   -type d -printf "%%%%dir /%%p\n" | egrep -v $n) >> %name.list
(cd $RPM_BUILD_ROOT ; find usr/%_lib/ocaml -name '*.so' -printf "/%%p\n" | egrep -v "labltk|camlp4|tkanim|jpflib|frxlib|graphics") > run.list
(cd $RPM_BUILD_ROOT ; find usr/%_lib/ocaml/labltk/ ! -name '*.so' -printf "/%%p\n") > labltk.list
(cd $RPM_BUILD_ROOT ; find usr/%_lib/ocaml -name '*.so' -printf "/%%p\n" | egrep "labltk|camlp4|tkanim|jpflib|frxlib|graphics") > rungrph.list

%files -f %name.list
%doc Changes LICENSE README 
%_menudir/ocaml
%_mandir/man1/ocaml*
%_mandir/man1/ocpp*
%_mandir/man3o/*
# %_datadir/emacs/site-lisp/*
# %config(noreplace) %_sysconfdir/emacs/site-start.d/*


%files doc
%doc htmlman/* stdlib.ps stdlib.pdf ocaml-3.08-refman.pdf ocaml-ora-book.pdf

%files -n ocaml-runtime -f run.list
%_bindir/ocamlrun
%dir %_libdir/ocaml
%dir %_libdir/ocaml/stublibs
%dir %_libdir/ocaml/site-lib
%dir %_libdir/ocaml/caml
%dir %_libdir/ocaml/ocamldoc
%dir %_libdir/ocaml/threads
%dir %_libdir/ocaml/vmthreads
%_libdir/ocaml/ld.conf

%files -n ocaml-graphics -f rungrph.list
%_libdir/ocaml/stublibs/dllgraphics.so
%_libdir/ocaml/stublibs/dlllabltk.so
%_libdir/ocaml/stublibs/dlltkanim.so
%_libdir/ocaml/graphics*
%_libdir/ocaml/libgraphics.a

%files -n labltk -f labltk.list
%doc otherlibs/labltk/README otherlibs/labltk/examples_labltk otherlibs/labltk/examples_camltk
%_bindir/*labltk*
%_bindir/ocamlbrowser

%files -n camlp4
%_mandir/man?/*camlp4*
%_bindir/*camlp4*
%_libdir/ocaml/camlp4

%changelog
* Sat Dec 09 2006 Konstantin A Lepikhov (L.A. Kostis) <lakostis@altlinux.ru> 3.09.3-alt0.1
- NMU.
- bugfix release.

* Sun Nov 12 2006 Grigory Batalov <bga@altlinux.ru> 3.09.1-alt3
- Built with Large File System support.

* Tue Mar 21 2006 Pavlov Konstantin <thresh@altlinux.ru> 3.09.1-alt2
- Added patch to use system-wide libtinfo (fixes findlib build).

* Wed Mar 01 2006 Pavlov Konstantin <thresh@altlinux.ru> 3.09.1-alt1
- Adopted package.
- Fixed #8944.
- New version.

* Thu Dec 22 2005 Pavlov Konstantin <thresh@altlinux.ru> 3.08.1-alt1.1
- NMU.
- %%'ed unused macroses.
- fixed %%_libdir/menu to %%_menudir.
- changed usr/lib in %%files section to usr/%%_lib.

* Tue Oct 26 2004 Vitaly Lugovsky <vsl@altlinux.ru> 3.08.1-alt1
- bugfix release

* Sat Jul 17 2004 Vitaly Lugovsky <vsl@altlinux.ru> 3.08.0-alt0.2
- 3.08.0 officially released

* Wed Jul 07 2004 Vitaly Lugovsky <vsl@altlinux.ru> 3.08-alt0.1
- current cvs

* Fri May  7 2004 Alexander V. Nikolaev <avn@altlinux.org> 3.07-alt6.1
- Non-Maintainer upload
- Rebuild with glibc 2.3.x
- Add packager to spec (Vitaly Lugovsky <vsl@altlinux.ru>)
- Gone build dependency on db2 (replace with libgdbm)

* Wed Mar 17 2004 Vitaly Lugovsky <vsl@altlinux.ru> 3.07-alt6
- CVS 3.07+14 with a current shared patch

* Tue Jan 20 2004 Vitaly Lugovsky <vsl@altlinux.ru> 3.07-alt5
- CVS 3.07+13 with a modified shared patch

* Wed Dec 17 2003 Vitaly Lugovsky <vsl@altlinux.ru> 3.07-alt4.2
Bugfix

* Tue Dec 16 2003 Vitaly Lugovsky <vsl@altlinux.ru> 3.07-alt4.1b
- Current CVS version merged.

* Mon Oct 13 2003 Vitaly Lugovsky <vsl@altlinux.ru> 3.07-alt2
A bugfix release

* Wed Oct 08 2003 Vitaly Lugovsky <vsl@altlinux.ru> 3.07-alt1
- Final 3.07 with a shared libs patch

* Wed Aug 27 2003 Vitaly Lugovsky <vsl@altlinux.ru> 3.07bs-alt0.1
- New version (3.07 beta CVS).

* Thu Jul 03 2003 Vitaly Lugovsky <vsl@altlinux.ru> 3.06s-alt5
- rebuild with a new binutils (now undefined symbols should be weak)

* Wed Mar 26 2003 Vitaly Lugovsky <vsl@altlinux.ru> 3.06s-alt4.2
- a bit of .spec cleanup
- merge with 3.1 (I'm *sorry*)
- russian description added
- a small bugfix patch (related to the bytecode profiling)

* Sat Mar 15 2003 Vitaly Lugovsky <vsl@altlinux.ru> 3.06s-alt4
- bugfix (ocaml-shared4fix.patch)

* Wed Mar 12 2003 Stanislav Ievlev <inger@altlinux.ru> 3.06s-alt3.1
- unmet fix: added provides to stdlib.so in runtime subpackage

* Tue Feb 25 2003 Vitaly Lugovsky <vsl@altlinux.ru> 3.06s-alt3
- stdlib.so now in the ocaml-runtime package

* Fri Jan 31 2003 Vitaly Lugovsky <vsl@altlinux.ru> 3.06s-alt1
- Malc's patch is here again. Ready for testing.
- X11 dependent module is in the separate package now
- Some .spec cleanups

* Tue Oct 22 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.06-alt4
- O'Relly book included in the docs package
- Some minor cleanups

* Fri Oct  4 2002 Sergey Bolshakov <s.bolshakov@belcaf.com> 3.06-alt3
- rebuilt with tcl 8.4

* Thu Sep 26 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.06-alt2
- tcllibdir in RPATH problem fixed
- now camltk library interface is emulated by labltk

* Tue Aug 20 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.06-alt1
- Bugfix release 3.06
- We have bytecode binaries again

* Mon Aug 12 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.05-alt3
- Ocaml package splitted: now we have runtime and
- development parts separated

* Wed Jul 31 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.05-alt2
- critical bugfix (in the bytecode runtime)

* Mon Jul 29 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.05-alt1
- New Objective Caml released: 3.05.
- Camlp4 manpages hack is obsolete now.

* Mon Jul 15 2002 Sergey Bolshakov <s.bolshakov@belcaf.com> 3.04_15-alt4
- rebuilt with new tcl layout

* Mon Jun 24 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04_15-alt2
- CVS version 3.04+15
- no more emacs mode installed.

* Tue May 14 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04_10-alt5
- CVS version of OCaml (3.04+10)
- naive patch about stdlib manuals (odoc bug?)
- pdf and postscript stdlib manual
- pdf ocaml reference manual moved to the ocaml-doc subpackage
- ldconf patch (to simplify installation of packages with dynamic libraries)

* Tue Apr 16 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04+9-alt8
- CVS version of OCaml (3.04+9),
- bytecode versions of compilers now included (due to the problem
   with threads).
- Threadhack patch from vsu <vsu@mivlgu.murom.ru>

* Wed Apr 3 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04+8-alt1
- CVS version of OCaml (3.04+8), with ocamldoc officialy included

* Sat Mar 2 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04+7-alt1
- CVS version of OCaml (3.04+7), shared patch and patch_record
  completely disabled.

* Mon Feb 4 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04-alt4
- Shared patch commented out (can't fix a bug with string_of_int)...
- make opt is now disabled for camlp4
- ocamltk renamed to labltk

* Wed Jan 23 2002 Vitaly Lugovsky <vsl@altlinux.ru> 3.04-alt3
- patch_record added

* Thu Jan 10 2002 Vitaly Lugovsky <warlock@skeptik.net> 3.04-vsl2
- Shared patch
- GCC 2.96 bug workaround patch
- -with-pthread
- PDF documentation included
- no-opt for debug and profile patch removed (what is it for?!?)
- installation/uninstallation of INFO removed

* Wed Jan 09 2002 Stanislav Ievlev <inger@altlinux.ru> 3.04-alt1
- 3.04. MDK merges

* Wed Aug 08 2001 Stanislav Ievlev <inger@altlinux.ru> 3.02-alt1
- 3.02

* Mon Jul 23 2001 Sergie Pugachev <fd_rag@altlinux.ru> 3.01-alt1
new version

* Sun Jan 14 2001 AEN <aen@logic.ru>
- RE adaptation

* Thu Nov  2 2000 Pixel <pixel@mandrakesoft.com> 3.00-23mdk
- fix silly #define clashing with new glibc

* Tue Oct 10 2000 Pixel <pixel@mandrakesoft.com> 3.00-22mdk
- add ocamltags (needs emacs)

* Mon Sep  4 2000 Pixel <pixel@mandrakesoft.com> 3.00-21mdk
- rebuild with spec-helper fixed

* Tue Aug 29 2000 Pixel <pixel@mandrakesoft.com> 3.00-20mdk
- fix info pages

* Tue Aug 29 2000 Pixel <pixel@mandrakesoft.com> 3.00-19mdk
- remove menu entry

* Wed Aug 23 2000 Pixel <pixel@mandrakesoft.com> 3.00-18mdk
- add packager

* Wed Aug 23 2000 Pixel <pixel@mandrakesoft.com> 3.00-17mdk
- add obsolete %name-emacs

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-16mdk
- nicer site-start.d/ocaml.el (use add-to-list)

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-15mdk
- fix missing %%config, add install info

* Tue Aug 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-14mdk
- use %_sysconfdir/emacs/site-start.d for the caml-mode.el
- merge %name and %name-emacs

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 3.00-13mdk
- automatically added BuildRequires

* Tue Aug 01 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 3.00-12mdk
- relink with the new and shiny tcltk

* Wed Jul 26 2000 Pixel <pixel@mandrakesoft.com> 3.00-11mdk
- use %%optflags with omit-frame-buffer removed

* Tue Jul 25 2000 Pixel <pixel@mandrakesoft.com> 3.00-10mdk
- use %%optflags (so that there is -mieee on alpha)

* Sat Jul 22 2000 Pixel <pixel@mandrakesoft.com> 3.00-9mdk
- patch for camldebug.el to workaround the silly ocamldebug command not looking
in cwd

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 3.00-7mdk
- more macro (use clean clean_menus)

* Wed Jul 19 2000 Pixel <pixel@mandrakesoft.com> 3.00-6mdk
- macroization
- BM

* Sun Jun 04 2000 David BAUDENS <baudens@mandrakesoft.com> 3.00-5mdk
- Fix %%doc
- Use %%_tmppath for BuildRoot

* Thu Jun  1 2000 Pixel <pixel@mandrakesoft.com> 3.00-4mdk
- change copyright

* Thu Jun  1 2000 Pixel <pixel@mandrakesoft.com> 3.00-3mdk
- takes care of ocamlbrowser and ocamldebug (these must not be stripped)

* Tue May 16 2000 Pixel <pixel@mandrakesoft.com> 3.00-2mdk
- add README to ocaml-emacs

* Mon May  1 2000 Pixel <pixel@mandrakesoft.com> 3.00-1mdk
- new version

* Mon Apr 10 2000 Pixel <pixel@mandrakesoft.com> 2.04-9mdk
- fix groups

* Tue Mar 28 2000 Pixel <pixel@mandrakesoft.com> 2.04-8mdk
- really add menu

* Mon Mar 27 2000 Pixel <pixel@mandrakesoft.com> 2.04-7mdk
- add menu

* Sat Mar 25 2000 Pixel <pixel@mandrakesoft.com> 2.04-6mdk
- new group + cleanup

* Mon Dec  6 1999 Pixel <pixel@linux-mandrake.com>
- 2.04

* Fri Nov 26 1999 Pixel <pixel@linux-mandrake.com>
- 2.03 + cleanup

* Tue Nov 23 1999 Pixel <pixel@linux-mandrake.com>
- build root added

* Tue Jun 01 1999 Pixel <pixel@linux-mandrake.com>
- Hacked to package properly ocamltk

* Tue Dec 29 1998 Alexey Nogin <ayn2@cornell.edu>
- Do not include any /usr/lib/ocaml/*.ml files

* Fri Dec 11 1998 Alexey Nogin <ayn2@cornell.edu>
- Updated to ocaml-2.01

* Sun Nov 29 1998 Alexey Nogin <ayn2@cornell.edu>
- Divided ocaml RPM into ocaml and ocaml-emacs RPMs
  to make it easier to have both ocaml and caml installed
  on the same machine

* Wed Nov 10 1998 Alexey Nogin <ayn2@cornell.edu>
- Changed SRPM according to RHCN Package Requirements
- Added LICENSE, Changelog and README files to the doc directory

